<a id="mypy-boto3-inspector2"></a>

# mypy-boto3-inspector2

[![PyPI - mypy-boto3-inspector2](https://img.shields.io/pypi/v/mypy-boto3-inspector2.svg?color=blue)](https://pypi.org/project/mypy-boto3-inspector2)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-inspector2.svg?color=blue)](https://pypi.org/project/mypy-boto3-inspector2)
[![Docs](https://img.shields.io/readthedocs/boto3-stubs.svg?color=blue)](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_inspector2/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-inspector2?color=blue)](https://pypistats.org/packages/mypy-boto3-inspector2)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.Inspector2 1.28.0](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/inspector2.html#Inspector2)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.14.5](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-inspector2 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_inspector2/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-inspector2](#mypy-boto3-inspector2)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `Inspector2`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `Inspector2` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[inspector2]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[inspector2]'


# standalone installation
python -m pip install mypy-boto3-inspector2
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-inspector2
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[inspector2]` in your environment:

```bash
python -m pip install 'boto3-stubs[inspector2]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[inspector2]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[inspector2]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[inspector2]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[inspector2]` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[inspector2]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[inspector2]` in your environment:

```bash
python -m pip install 'boto3-stubs[inspector2]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[inspector2]` in your environment:

```bash
python -m pip install 'boto3-stubs[inspector2]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`Inspector2Client` provides annotations for `boto3.client("inspector2")`.

```python
from boto3.session import Session

from mypy_boto3_inspector2 import Inspector2Client

client: Inspector2Client = Session().client("inspector2")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_inspector2.paginator` module contains type annotations for all
paginators.

```python
from boto3.session import Session

from mypy_boto3_inspector2 import Inspector2Client
from mypy_boto3_inspector2.paginator import (
    ListAccountPermissionsPaginator,
    ListCoveragePaginator,
    ListCoverageStatisticsPaginator,
    ListDelegatedAdminAccountsPaginator,
    ListFiltersPaginator,
    ListFindingAggregationsPaginator,
    ListFindingsPaginator,
    ListMembersPaginator,
    ListUsageTotalsPaginator,
    SearchVulnerabilitiesPaginator,
)

client: Inspector2Client = Session().client("inspector2")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
list_account_permissions_paginator: ListAccountPermissionsPaginator = client.get_paginator(
    "list_account_permissions"
)
list_coverage_paginator: ListCoveragePaginator = client.get_paginator("list_coverage")
list_coverage_statistics_paginator: ListCoverageStatisticsPaginator = client.get_paginator(
    "list_coverage_statistics"
)
list_delegated_admin_accounts_paginator: ListDelegatedAdminAccountsPaginator = client.get_paginator(
    "list_delegated_admin_accounts"
)
list_filters_paginator: ListFiltersPaginator = client.get_paginator("list_filters")
list_finding_aggregations_paginator: ListFindingAggregationsPaginator = client.get_paginator(
    "list_finding_aggregations"
)
list_findings_paginator: ListFindingsPaginator = client.get_paginator("list_findings")
list_members_paginator: ListMembersPaginator = client.get_paginator("list_members")
list_usage_totals_paginator: ListUsageTotalsPaginator = client.get_paginator("list_usage_totals")
search_vulnerabilities_paginator: SearchVulnerabilitiesPaginator = client.get_paginator(
    "search_vulnerabilities"
)
```

<a id="literals"></a>

### Literals

`mypy_boto3_inspector2.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_inspector2.literals import (
    AccountSortByType,
    AggregationFindingTypeType,
    AggregationResourceTypeType,
    AggregationTypeType,
    AmiSortByType,
    ArchitectureType,
    AwsEcrContainerSortByType,
    CodeSnippetErrorCodeType,
    CoverageMapComparisonType,
    CoverageResourceTypeType,
    CoverageStringComparisonType,
    CurrencyType,
    DelegatedAdminStatusType,
    Ec2DeepInspectionStatusType,
    Ec2InstanceSortByType,
    Ec2PlatformType,
    EcrRescanDurationStatusType,
    EcrRescanDurationType,
    EcrScanFrequencyType,
    ErrorCodeType,
    ExploitAvailableType,
    ExternalReportStatusType,
    FilterActionType,
    FindingStatusType,
    FindingTypeSortByType,
    FindingTypeType,
    FixAvailableType,
    FreeTrialInfoErrorCodeType,
    FreeTrialStatusType,
    FreeTrialTypeType,
    GroupKeyType,
    ImageLayerSortByType,
    LambdaFunctionSortByType,
    LambdaLayerSortByType,
    ListAccountPermissionsPaginatorName,
    ListCoveragePaginatorName,
    ListCoverageStatisticsPaginatorName,
    ListDelegatedAdminAccountsPaginatorName,
    ListFiltersPaginatorName,
    ListFindingAggregationsPaginatorName,
    ListFindingsPaginatorName,
    ListMembersPaginatorName,
    ListUsageTotalsPaginatorName,
    MapComparisonType,
    NetworkProtocolType,
    OperationType,
    PackageManagerType,
    PackageSortByType,
    PackageTypeType,
    RelationshipStatusType,
    ReportFormatType,
    ReportingErrorCodeType,
    RepositorySortByType,
    ResourceMapComparisonType,
    ResourceScanTypeType,
    ResourceStringComparisonType,
    ResourceTypeType,
    RuntimeType,
    SbomReportFormatType,
    ScanStatusCodeType,
    ScanStatusReasonType,
    ScanTypeType,
    SearchVulnerabilitiesPaginatorName,
    ServiceType,
    SeverityType,
    SortFieldType,
    SortOrderType,
    StatusType,
    StringComparisonType,
    TitleSortByType,
    UsageTypeType,
    VulnerabilitySourceType,
    Inspector2ServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: AccountSortByType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_inspector2.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_inspector2.type_defs import (
    SeverityCountsTypeDef,
    AccountAggregationTypeDef,
    StateTypeDef,
    ResourceStatusTypeDef,
    FindingTypeAggregationTypeDef,
    StringFilterTypeDef,
    AssociateMemberRequestRequestTypeDef,
    AssociateMemberResponseTypeDef,
    AtigDataTypeDef,
    AutoEnableTypeDef,
    AwsEc2InstanceDetailsTypeDef,
    AwsEcrContainerImageDetailsTypeDef,
    LambdaVpcConfigTypeDef,
    BatchGetAccountStatusRequestRequestTypeDef,
    BatchGetCodeSnippetRequestRequestTypeDef,
    CodeSnippetErrorTypeDef,
    BatchGetFreeTrialInfoRequestRequestTypeDef,
    FreeTrialInfoErrorTypeDef,
    BatchGetMemberEc2DeepInspectionStatusRequestRequestTypeDef,
    FailedMemberAccountEc2DeepInspectionStatusStateTypeDef,
    MemberAccountEc2DeepInspectionStatusStateTypeDef,
    MemberAccountEc2DeepInspectionStatusTypeDef,
    CancelFindingsReportRequestRequestTypeDef,
    CancelFindingsReportResponseTypeDef,
    CancelSbomExportRequestRequestTypeDef,
    CancelSbomExportResponseTypeDef,
    CisaDataTypeDef,
    CodeFilePathTypeDef,
    CodeLineTypeDef,
    SuggestedFixTypeDef,
    CountsTypeDef,
    CoverageDateFilterTypeDef,
    CoverageMapFilterTypeDef,
    CoverageStringFilterTypeDef,
    ScanStatusTypeDef,
    CreateFilterResponseTypeDef,
    DestinationTypeDef,
    CreateFindingsReportResponseTypeDef,
    CreateSbomExportResponseTypeDef,
    Cvss2TypeDef,
    Cvss3TypeDef,
    CvssScoreAdjustmentTypeDef,
    CvssScoreTypeDef,
    DateFilterTypeDef,
    DelegatedAdminAccountTypeDef,
    DelegatedAdminTypeDef,
    DeleteFilterRequestRequestTypeDef,
    DeleteFilterResponseTypeDef,
    DisableDelegatedAdminAccountRequestRequestTypeDef,
    DisableDelegatedAdminAccountResponseTypeDef,
    DisableRequestRequestTypeDef,
    DisassociateMemberRequestRequestTypeDef,
    DisassociateMemberResponseTypeDef,
    MapFilterTypeDef,
    Ec2MetadataTypeDef,
    EcrRescanDurationStateTypeDef,
    EcrConfigurationTypeDef,
    EcrContainerImageMetadataTypeDef,
    EcrRepositoryMetadataTypeDef,
    EnableDelegatedAdminAccountRequestRequestTypeDef,
    EnableDelegatedAdminAccountResponseTypeDef,
    EnableRequestRequestTypeDef,
    EpssDetailsTypeDef,
    EpssTypeDef,
    ExploitObservedTypeDef,
    ExploitabilityDetailsTypeDef,
    NumberFilterTypeDef,
    PortRangeFilterTypeDef,
    FreeTrialInfoTypeDef,
    GetEc2DeepInspectionConfigurationResponseTypeDef,
    GetEncryptionKeyRequestRequestTypeDef,
    GetEncryptionKeyResponseTypeDef,
    GetFindingsReportStatusRequestRequestTypeDef,
    GetMemberRequestRequestTypeDef,
    MemberTypeDef,
    GetSbomExportRequestRequestTypeDef,
    LambdaFunctionMetadataTypeDef,
    ListAccountPermissionsRequestListAccountPermissionsPaginateTypeDef,
    ListAccountPermissionsRequestRequestTypeDef,
    PermissionTypeDef,
    ListDelegatedAdminAccountsRequestListDelegatedAdminAccountsPaginateTypeDef,
    ListDelegatedAdminAccountsRequestRequestTypeDef,
    ListFiltersRequestListFiltersPaginateTypeDef,
    ListFiltersRequestRequestTypeDef,
    SortCriteriaTypeDef,
    ListMembersRequestListMembersPaginateTypeDef,
    ListMembersRequestRequestTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    ListUsageTotalsRequestListUsageTotalsPaginateTypeDef,
    ListUsageTotalsRequestRequestTypeDef,
    StepTypeDef,
    PortRangeTypeDef,
    VulnerablePackageTypeDef,
    PaginatorConfigTypeDef,
    RecommendationTypeDef,
    ResetEncryptionKeyRequestRequestTypeDef,
    ResourceMapFilterTypeDef,
    ResourceStringFilterTypeDef,
    ResponseMetadataTypeDef,
    SearchVulnerabilitiesFilterCriteriaTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateEc2DeepInspectionConfigurationRequestRequestTypeDef,
    UpdateEc2DeepInspectionConfigurationResponseTypeDef,
    UpdateEncryptionKeyRequestRequestTypeDef,
    UpdateFilterResponseTypeDef,
    UpdateOrgEc2DeepInspectionConfigurationRequestRequestTypeDef,
    UsageTypeDef,
    AccountAggregationResponseTypeDef,
    AmiAggregationResponseTypeDef,
    AwsEcrContainerAggregationResponseTypeDef,
    Ec2InstanceAggregationResponseTypeDef,
    FindingTypeAggregationResponseTypeDef,
    ImageLayerAggregationResponseTypeDef,
    LambdaFunctionAggregationResponseTypeDef,
    LambdaLayerAggregationResponseTypeDef,
    PackageAggregationResponseTypeDef,
    RepositoryAggregationResponseTypeDef,
    TitleAggregationResponseTypeDef,
    ResourceStateTypeDef,
    AccountTypeDef,
    FailedAccountTypeDef,
    AmiAggregationTypeDef,
    AwsEcrContainerAggregationTypeDef,
    ImageLayerAggregationTypeDef,
    LambdaLayerAggregationTypeDef,
    PackageAggregationTypeDef,
    RepositoryAggregationTypeDef,
    TitleAggregationTypeDef,
    DescribeOrganizationConfigurationResponseTypeDef,
    UpdateOrganizationConfigurationRequestRequestTypeDef,
    UpdateOrganizationConfigurationResponseTypeDef,
    AwsLambdaFunctionDetailsTypeDef,
    BatchGetMemberEc2DeepInspectionStatusResponseTypeDef,
    BatchUpdateMemberEc2DeepInspectionStatusResponseTypeDef,
    BatchUpdateMemberEc2DeepInspectionStatusRequestRequestTypeDef,
    CodeVulnerabilityDetailsTypeDef,
    CodeSnippetResultTypeDef,
    ListCoverageStatisticsResponseTypeDef,
    CoverageFilterCriteriaTypeDef,
    CvssScoreDetailsTypeDef,
    ListDelegatedAdminAccountsResponseTypeDef,
    GetDelegatedAdminAccountResponseTypeDef,
    Ec2InstanceAggregationTypeDef,
    LambdaFunctionAggregationTypeDef,
    EcrConfigurationStateTypeDef,
    UpdateConfigurationRequestRequestTypeDef,
    VulnerabilityTypeDef,
    PackageFilterTypeDef,
    FreeTrialAccountInfoTypeDef,
    GetMemberResponseTypeDef,
    ListMembersResponseTypeDef,
    ResourceScanMetadataTypeDef,
    ListAccountPermissionsResponseTypeDef,
    NetworkPathTypeDef,
    PackageVulnerabilityDetailsTypeDef,
    RemediationTypeDef,
    ResourceFilterCriteriaTypeDef,
    SearchVulnerabilitiesRequestRequestTypeDef,
    SearchVulnerabilitiesRequestSearchVulnerabilitiesPaginateTypeDef,
    UsageTotalTypeDef,
    AggregationResponseTypeDef,
    AccountStateTypeDef,
    DisableResponseTypeDef,
    EnableResponseTypeDef,
    ResourceDetailsTypeDef,
    BatchGetCodeSnippetResponseTypeDef,
    ListCoverageRequestListCoveragePaginateTypeDef,
    ListCoverageRequestRequestTypeDef,
    ListCoverageStatisticsRequestListCoverageStatisticsPaginateTypeDef,
    ListCoverageStatisticsRequestRequestTypeDef,
    InspectorScoreDetailsTypeDef,
    AggregationRequestTypeDef,
    GetConfigurationResponseTypeDef,
    SearchVulnerabilitiesResponseTypeDef,
    FilterCriteriaTypeDef,
    BatchGetFreeTrialInfoResponseTypeDef,
    CoveredResourceTypeDef,
    NetworkReachabilityDetailsTypeDef,
    CreateSbomExportRequestRequestTypeDef,
    GetSbomExportResponseTypeDef,
    ListUsageTotalsResponseTypeDef,
    ListFindingAggregationsResponseTypeDef,
    BatchGetAccountStatusResponseTypeDef,
    ResourceTypeDef,
    ListFindingAggregationsRequestListFindingAggregationsPaginateTypeDef,
    ListFindingAggregationsRequestRequestTypeDef,
    CreateFilterRequestRequestTypeDef,
    CreateFindingsReportRequestRequestTypeDef,
    FilterTypeDef,
    GetFindingsReportStatusResponseTypeDef,
    ListFindingsRequestListFindingsPaginateTypeDef,
    ListFindingsRequestRequestTypeDef,
    UpdateFilterRequestRequestTypeDef,
    ListCoverageResponseTypeDef,
    FindingTypeDef,
    ListFiltersResponseTypeDef,
    ListFindingsResponseTypeDef,
)


def get_structure() -> SeverityCountsTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-inspector2` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_inspector2/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
